/******************************************************************************
;  *   	@ͺ				  : MC32P7311
;  *   	@             : 2021.08.04
;  *   	@˾/			  : SINOMCU-FAE
;  *   	@΢֧       : 2048615934
;  *   	@΢           : http://www.sinomcu.com/
;  *   	@Ȩ                 : 2021 SINOMCU˾Ȩ.
;  *----------------------ժҪ---------------------------------
;  *   	   	   	            5sģʽP17͵ƽ
   	   	   	   	   	   	   	P11жϻѣP17ߵƽ                          	   	
******************************************************************************/

#include "user.h"

/************************************************
;  *    @Function Name       : CLR_RAM
;  *    @Description         : ʼRAM
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void CLR_RAM(void)
{
   	for (FSR0 = 0; FSR0 < 0xff; FSR0++)
   	{
   	   	INDF0 = 0x00;
   	}
   	FSR0 = 0xFF;
   	INDF0 = 0x00;
}
/************************************************
;  *    @Function Name       : IO_Init
;  *    @Description         : ioڳʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void IO_Init(void)
{
   	IOP0 = 0x00;   //ioλ
   	OEP0 = 0xFF;   //ioڷ 1:out  0:in   P001Ϊ©
   	PUP0 = 0x00;   //io   1:enable  0:disable
   	PDP0 = 0x00;   //io   1:enable  0:disable
   	ANSEL0 = 0x00; //ioѡ  1:ģ  0:ͨio

   	IOP1 = 0x00;   //ioλ
   	OEP1 = 0xFF;   //ioڷ 1:out  0:in   P13Ϊ©
   	PUP1 = 0x00;   //io   1:enable  0:disable
   	PDP1 = 0x00;   //io   1:enable  0:disable
   	ANSEL1 = 0x00; //ioѡ  1:ģ  0:ͨio

   	DRVCR = 0x80;
}
/************************************************
;  *    @Function Name       : TIMER0_INT_Init
;  *    @Description         : 
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void TIMER0_INT_Init(void)
{
   	T0CR |= 0x84; //Fcpu 16
   	T0CNT = 249;
   	T0LOAD = 249; //1ms
   	T0IE = 1;
}
/************************************************
;  *    @Function Name       : KBIE_Init
;  *    @Description         : 
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void KBIE_Init(void)
{
   	OEP1 = 0xfd; //in
   	PUP1 = 0x02; //
   	KBCR = 0x02; //P11ж
}
/************************************************
;  *    @Function Name       : Sys_Init
;  *    @Description         : ϵͳʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void Sys_Init(void)
{
   	GIE = 0;
   	CLR_RAM();
   	IO_Init();
   	TIMER0_INT_Init();
   	KBIE_Init();
   	GIE = 1;
}
void main(void)
{
   	Sys_Init();
   	while (1)
   	{
   	   	if (FLAG_TIMER0_5000ms)
   	   	{
   	   	   	FLAG_TIMER0_5000ms = 0;
   	   	   	GIE = 0;
   	   	   	KBIF = 0;
   	   	   	KBIE = 1;
   	   	   	//ǰر AD ʹܻж
   	   	   	P17D=0;
   	   	   	Nop();
   	   	   	Nop();
   	   	   	Stop();
   	   	   	Nop();
   	   	   	Nop();
   	   	   	KBIE = 0;
   	   	   	KBIF = 0;
   	   	   	GIE = 1;
   	   	   	//ѺʹرռжϣʵӦû
   	   	   	P17D=1;
   	   	}
   	}
}
void int_isr(void) __interrupt
{
__asm 
   	movra _abuf
   	swapar _PFLAG
   	movra _statusbuf
__endasm;
   	//=======T0========================
   	if (T0IF & T0IE)
   	{
   	   	T0IF = 0;
   	   	timer0_num++;
   	   	if (timer0_num >= 5000) //5s
   	   	{
   	   	   	timer0_num = 0;
   	   	   	FLAG_TIMER0_5000ms = 1;
   	   	}
   	}
__asm 
   	swapar _statusbuf
   	movra _PFLAG
   	swapr _abuf
   	swapar _abuf
__endasm;
}
