/******************************************************************************
;  *   	@ͺ				  : MC32P7311
;  *   	@             : 2021.08.04
;  *   	@˾/			  : SINOMCU-FAE
;  *   	@΢֧       : 2048615934
;  *   	@΢           : http://www.sinomcu.com/
;  *   	@Ȩ                 : 2021 SINOMCU˾Ȩ.
;  *----------------------ժҪ---------------------------------
;  *   	   	   	   	   ϵP17 PWM T0ʱ5mSƵһ
******************************************************************************/

#include "user.h"

/************************************************
;  *    @Function Name       : CLR_RAM
;  *    @Description         : ʼRAM
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/  
void CLR_RAM(void)
{      	       	
    for(FSR0=0;FSR0<0xff;FSR0++) 
   	{
   	   	INDF0=0x00;
   	}
   	FSR0=0xFF;
   	INDF0=0x00;    	   	
}
/************************************************
;  *    @Function Name       : IO_Init
;  *    @Description         : ioڳʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/  
void IO_Init(void)
{
   	IOP0=0x00; 	   	   	//ioλ
   	OEP0=0xFF; 	   	   	//ioڷ 1:out  0:in   P001Ϊ©
   	PUP0=0x00; 	   	   	//io   1:enable  0:disable
   	PDP0=0x00; 	   	   	//io   1:enable  0:disable
   	ANSEL0=0x00;   	   	//ioѡ  1:ģ  0:ͨio
   	
   	IOP1=0x00; 	   	   	//ioλ
   	OEP1=0xFF; 	   	   	//ioڷ 1:out  0:in   P13Ϊ©
   	PUP1=0x00; 	   	   	//io   1:enable  0:disable
   	PDP1=0x00; 	   	   	//io   1:enable  0:disable
   	ANSEL1=0x00;   	   	//ioѡ  1:ģ  0:ͨio

   	DRVCR=0x80;
}
/************************************************
;  *    @Function Name       : TIMER0_INT_Init
;  *    @Description         : 
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void TIMER0_INT_Init(void)
{
   	T0CR|=0x83;	   	   	//Fcpu 8
   	T0CNT=249;
   	T0LOAD=249;   //500US
   	T0IE=1;
}
/************************************************
;  *    @Function Name       : TIMER1_PWM_Init
;  *    @Description         : 
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void TIMER1_PWM_Init(void)     	   	
{
   	T1CR=0xC8; 	   	//FHOSC   
   	PWMCR1=0x00;   	//TMRCKS=16M   	   	
   	T1CNT=9;
   	T1LOAD=9;
   	T1DATA=5;
}
/************************************************
;  *    @Function Name       : Sys_Init
;  *    @Description         : ϵͳʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/  
void Sys_Init(void)
{
   	GIE = 0;
   	CLR_RAM();
   	IO_Init();
    TIMER0_INT_Init();
   	TIMER1_PWM_Init();
   	GIE=1;        
}
/************************************************
;  *    @Function Name       : HIRC_ADD_Deal
;  *    @Description         : 
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void HIRC_ADD_Deal(void)
{
   	while(STBL==0);
   	CLKS=1;    	
   	system_freqH=OSCCALH;
   	system_freqL=OSCCALL;  	
   	system_freqL=system_freqL+1;   	
   	if(system_freqL==0x00)//λ
   	{
   	   	system_freqH=system_freqH+1;
   	   	system_freqH1=system_freqH&0x07;//OSCCALHλ޸
   	   	if(system_freqH1==0x00)
   	   	{
   	   	   	FLAG_SYS=1;
   	   	   	system_freqH=0x07;
   	   	   	system_freqL=0xff;
   	   	}  	   	
   	}
   	OSCCALH=system_freqH;
   	OSCCALL=system_freqL;      	
   	while(STBH==0);
   	CLKS=0;	
}
/************************************************
;  *    @Function Name       : HIRC_SUB_Deal
;  *    @Description         : 
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void HIRC_SUB_Deal(void)
{
   	while(STBL==0);
   	CLKS=1;    	
   	system_freqH=OSCCALH;
   	system_freqL=OSCCALL;      	
   	system_freqL=system_freqL-1;   
   	if(system_freqL==0xff)
   	{
   	   	system_freqH=system_freqH-1;
   	   	system_freqH1=system_freqH&0x07;
   	   	if(system_freqH1==0x07)
   	   	{
   	   	   	FLAG_SYS=0;
   	   	   	system_freqH=0;
   	   	   	system_freqL=0;
   	   	}
   	}
   	OSCCALH=system_freqH;
   	OSCCALL=system_freqL;  	
   	while(STBH==0);
   	CLKS=0;	
}
void main(void) 
{
   	Sys_Init();
   	HFEN=1;
   	LFEN=1;	   	//ߵƵʼչ
   	while(1)
   	{
   	   	if(FLAG_TIMER0_5ms)
   	   	{
   	   	   	FLAG_TIMER0_5ms=0;
   	   	   	if(FLAG_SYS==0)
   	   	   	{
   	   	   	   	HIRC_ADD_Deal();
   	   	   	}else HIRC_SUB_Deal(); 	   	
       	}      	   	
   	}
}

void int_isr(void) __interrupt
{
   	__asm
   	   	movra   _abuf
   	   	swapar  _PFLAG
   	   	movra   _statusbuf
   	__endasm;
//=======T0========================
   if(T0IF&T0IE)
   	{
   	   	T0IF=0;
   	   	timer0_num++;
   	   	if(timer0_num>=10) 	   	//5ms
   	   	{
   	   	   	timer0_num=0;
   	   	   	FLAG_TIMER0_5ms=1;
   	   	   	P15D=!P15D;
   	   	}
   	}
   	__asm
   	   	swapar  _statusbuf
   	   	movra   _PFLAG
   	   	swapr   _abuf
   	   	swapar  _abuf
   	__endasm;
}




























